package cn.efunbox.manage.base.repository;

import cn.efunbox.manage.base.entity.Department;
import cn.efunbox.manage.base.enums.BaseStatusEnum;
import cn.efunbox.manage.base.enums.DeptTypeEnum;
import cn.efunbox.manage.common.data.BasicRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;

import java.util.List;


public interface DepartmentRepository extends BasicRepository<Department> {

    List<Department> findByPathAndStatusInOrderBySortAsc(Long path, List<BaseStatusEnum> status);

    List<Department> findByStatusOrderBySortDesc(BaseStatusEnum status);

    @Query(value = "select * from department where status = 0 and type = :type and id not in ('12345','123456','1234567', '12345678') order by code", nativeQuery = true)
    List<Department> findSelect(@Param("type") Integer type);

    Department findByName(String name);

    List<Department> findByPathAndTypeAndStatusInOrderByCodeAsc(Long cid, DeptTypeEnum deptTypeEnum, List<BaseStatusEnum> status);
}
