package cn.efunbox.manage.base.controller;

import cn.efunbox.manage.base.entity.Department;
import cn.efunbox.manage.base.entity.Manage;
import cn.efunbox.manage.base.enums.DeptTypeEnum;
import cn.efunbox.manage.base.service.DepartmentService;
import cn.efunbox.manage.base.service.ManageService;
import cn.efunbox.manage.base.vo.ManageVO;
import cn.efunbox.manage.common.result.ApiResult;
import org.apache.http.HttpResponse;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

/**
 * ManageController
 * Created by wangys on 2019/03/08
 */
@RequestMapping("/manage")
@RestController
public class ManageController {

    @Autowired
    ManageService manageService;

    @Autowired
    DepartmentService departmentService;

    @PostMapping("/search")
    public ApiResult findManage(@RequestBody ManageVO manageVO){
        List<Long> deptIds = new ArrayList<>();
        if(null == manageVO.getDeptId() || manageVO.getDeptId().size() ==0){
            ApiResult<List<Department>> deptResult = departmentService.getDeptChild(12345l, DeptTypeEnum.COMPANY);
            deptResult.getData().stream().forEach(department -> {
                deptIds.add(department.getId());
            });
        }else {
            manageVO.getDeptId().stream().forEach(ids -> {
                deptIds.add(ids);
            });
        }

        manageVO.setDeptIds(deptIds);
        return manageService.list(manageVO);
    }

    @GetMapping("/export")
    public void export(ManageVO manageVO, HttpServletResponse response) throws Exception{
        List<Long> deptIds = new ArrayList<>();
        if(null == manageVO.getDeptId() || manageVO.getDeptId().size() ==0){
            ApiResult<List<Department>> deptResult = departmentService.getDeptChild(12345l, DeptTypeEnum.COMPANY);
            deptResult.getData().stream().forEach(department -> {
                deptIds.add(department.getId());
            });
        }else {
            manageVO.getDeptId().stream().forEach(ids -> {
                deptIds.add(ids);
            });
        }

        manageVO.setDeptIds(deptIds);
        manageService.export(manageVO, response);
    }

    @PostMapping
    public ApiResult save(@RequestBody Manage manage){
        return manageService.save(manage);
    }

    @PutMapping
    public ApiResult update(@RequestBody Manage manage){
        return manageService.update(manage);
    }

    @GetMapping("/{id}")
    public ApiResult getManageById(@PathVariable(name = "id") Long manageId){
        return manageService.getById(manageId);
    }
}
